package main

import "fmt"

// 如题，map和slice是引用类型还是值类型
func main() {
	// slice
	s := []int{1, 2, 3}
	testSlice(s)
	fmt.Println(s) // [100 2 3]

	// map
	m := map[string]int{"test": 1}
	testMap(m)
	fmt.Println(m) // map[test:100]
	// 结论：map和slice都是引用类型
}

// 写一个函数，传入一个slice，修改slice的值，看看是否会影响到原来的slice
func testSlice(s []int) {
	s[0] = 100
}

// 写一个函数，传入一个map，修改map的值，看看是否会影响到原来的map
func testMap(m map[string]int) {
	m["test"] = 100
}
