package main

import "fmt"

func main() {
	// 先来看个例子
	var num *int
	var a interface{}

	fmt.Println(num == nil) // true
	fmt.Println(a == nil)   // true
	fmt.Println(a == num)   // false

	// 我将会用(Type, Value)来表示一个变量完整的类型和值
	fmt.Printf("num:(%T, %[1]v)\n", num) // num:(*int <nil>)
	fmt.Printf("a:(%T, %[1]v)\n", a)     // a:(<nil>, <nil>)

	fmt.Println(num == nil) // (*int, nil) == (*int, nil) // true
	fmt.Println(a == nil)   // (<nil>, <nil>) == (<nil>, <nil>) // true
	fmt.Println(a == num)   // (<nil>, <nil>) == (*int, nil) // false

	// 从上面的例子可以看出，interface{}类型的值和nil比较时，会先判断类型是否相同，如果类型相同，再判断值是否相同

	// 再来看个例子
	var num2 *int = nil
	var b interface{} = num2 // 在这里，b的动态类型已经是(*int, nil)
	fmt.Println(b == nil)    // (<*int>, <nil>) == (<nil>, <nil>) // false
	fmt.Println(num2 == nil) // (<*int>, <nil>) == (<*int>, <nil>) // true
	fmt.Println(b == num2)   // (<*int>, <nil>) == (<*int>, <nil>) // true

}
