package main

import (
	"bytes"
	"fmt"
	"io"
)

type err string

func (err err) Error() string {
	return string(err)
}

const EOF = err("EOF")

func main() {
	reader := bytes.NewBuffer([]byte{1, 2, 3})
	result, err := io.ReadAll(reader)
	fmt.Println(result, err)
}

func init() {
	io.EOF = EOF
}
